<?php

namespace Drp\LaravelSetup\Commands;

use Drp\LaravelSetup\Database\CreateDatabase;
use Drp\LaravelSetup\Database\Env\Writer;
use Illuminate\Console\Command;

class SetupDatabase extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'setup:database {--env-file=.env} {--db-name=my-project}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Setup a new database';

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $defaultDbName = $this->option('db-name');
        $envFilePath = $this->option('env-file');

        $databaseBuilder = new CreateDatabase(new Writer([
            'dbHost' => 'DB_HOST',
            'dbPort' => 'DB_PORT',
            'dbUsername' => 'DB_USERNAME',
            'dbPassword' => 'DB_PASSWORD',
            'dbName' => 'DB_DATABASE',
        ], $envFilePath));

        return $databaseBuilder->setOutput($this)->execute($defaultDbName);
    }
}
