<?php

namespace Drp\LaravelSetup\Initializer;

use MadWeb\Initializer\Run as MadWebRun;
use Symfony\Component\Console\Output\OutputInterface;

class Run extends MadWebRun
{
    /**
     * Runs all the commands given in the callback with full verbosity. Best used
     * when running commands requiring user input.
     */
    public function withVerbosity(callable $callback, int $verbosity = OutputInterface::VERBOSITY_VERBOSE): self
    {
        $previousVerbosity = (function () use ($verbosity) {
            $previous = $this->verbosity;
            $this->setVerbosity($verbosity);
            $this->output->setVerbosity($verbosity);

            return $previous;
        })->call($this->artisanCommand);

        $callback();

        (function () use ($previousVerbosity): void {
            /** @var \Illuminate\Console\Command $this */
            $this->setVerbosity($previousVerbosity);
            $this->output->setVerbosity($previousVerbosity);
        })->call($this->artisanCommand);

        return $this;
    }
}
